Salesforce Composite Connector SObject Tree Demo
===========================

INTRODUCTION
------------
The Salesforce Composite Sobject Tree Demo project consists of below flow:

* salesforce-composite-create-sobject-trees - Provides an example on how to create SObject Trees with Account type as root in Salesforce.

HOW TO RUN DEMO
---------------

## Prerequisites

* Java 7 
* Anypoint Studio 5.4.x
* Mule Runtime 3.7.0 EE
* DataWeave
* Access to a Salesforce instance

## Import the demo project into Anypoint Studio

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Import Menu](images/import-project.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/import-project-1.png)

* Click **Finish**.  
* Set Salesforce credentials inside the file `src/main/app/mule-app.properties`.


	
	config.username=<USERNAME> user name within Salesforce system

	config.password=<PASSWORD> password within Salesforce system

	config.consumerKey=<CONSUMER_KEY> consumer key of the connected app through which you are accessing salesforce
 
	config.consumerSecret=<CONSUMER_SECRET> consumer secret of the connected app through which you are accessing salesforce

	config.securityToken=<SECURITY_TOKEN> security token within Salesforce system

	config.tokenEndpoint=<ENDPOINT_REST_URL> e.g https://login.salesforce.com/services/oauth2/token [url to server responsible for authentication]
	


How To Run the Demo
-------------------
* Run the demo application by selecting **Run as Mule Application** 
* Open a browser and access the URL `http://localhost:8081`. You should see the demo application deployed:

A html form with will show up which allows to access the selection menu of the demo.


![Demo Index](images/demo-home.png)

About the Demo
--------------


The project provides one form containing the information necessary for the create sobject tree operation. 
Using the input sample from treesample.json a tree of Accounts and Contacts will be created in Salesforce.



## About the flows

### 1. Create sobject tree flow

**1.1 salesforce-composite-sobject-tree-initial-page-flow.png**:contains an "HTTP" endpoint binded to "/" and is responsible of parsing "src/main/resources/form.html" and returning it.

It contains a html form having a field which contains the json tree structure of the sobject. The data are submitted to "/create-trees" via ajax call when user clicks on "Create the given SObject Trees"  

![Demo Index](images/salesforce-composite-sobject-tree-initial-page-flow.png)

**1.2 salesforce-composite-create-sobject-trees**: contains an "HTTP" endpoint binded to "/create-trees" and is responsible of formatting input data that comes with the request, execute the request against Salesforce, log the response and transform the response from Salesforce to json.
 
![Demo Index](images/salesforce-composite-create-sobject-trees.png)

### 2. Get input flows

**2.1 get-input-tree**: contains an "HTTP" endpoint binded to "/get-input-tree" and is responsible of reading "/src/main/resources/treesample.json" and returning it to the UI- 'form.html'.

![Demo Index](images/get-input-tree.png)


**2.1 get-loader-image**: contains an "HTTP" endpoint binded to "/get-loader-image" and is responsible of returning a gif loader resource.

![Demo Index](images/get-loader-image.png)	